<template>
  <form id="addItemForm" @submit.prevent="emitNewItem">
    <label for="nameInput">Name </label>
    <input
      type="text"
      name="nameInput"
      placeholder="Enter name here..."
      required
    />
    <br />
    <label for="priceInput">Price </label>
    <span>£</span>
    <input
      type="number"
      name="priceInput"
      min="0.1"
      max="999"
      step="0.01"
      placeholder="0.99"
      required
    />
    <br />
    <a-button html-type="submit">Add</a-button>
  </form>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { AddItemModel } from "@/interfaces/interfaces";

@Component
export default class AddItemForm extends Vue {
  private emitNewItem(): void {
    const form = document.getElementById("addItemForm") as HTMLElement;
    const nameInput = form.querySelector(
      "input[name=nameInput]"
    ) as HTMLInputElement;
    const priceInput = form.querySelector(
      "input[name=priceInput]"
    ) as HTMLInputElement;

    const newItem: AddItemModel = {
      name: nameInput.value.toLowerCase(),
      unitPrice: parseFloat(priceInput.value)
    };

    this.$emit("emitform", newItem);
  }
}
</script>
